import { isFunction, flatMap } from 'lodash';

import MouseTrap from './mousetrap';

const _ = function e( r: any ) {
  // TODO: check this
  // @ts-ignore
  return MouseTrap.stopCallback( r, r.target );
};

const h = function e( r: any, t: any ) {
  return function() {
    const xx = arguments.length <= 0 ? void 0 : arguments[ 0 ];
    if ( t( xx ) ) return;
    r.apply( void 0, arguments );
  };
};

const f = function e( r: any, t: any ): void {
  const n = t[ 0 ];
  return n ? e( h( r, n ), t.slice( 1 ) ) : r;
};

const m = function e( r: any ) {
  const t = r.ignoreInputs && _;
  return [ t, r.filter ].filter( isFunction );
};

export class KeyCommands {
  private mousetrap: MouseTrap;
  constructor() {
    this.mousetrap = new MouseTrap();
  }

  bindAll( r: any ) {
    const t = this;
    r.forEach( function( e: any ) {
      const rr = m( e );
      e.handler = f( e.handler, rr );
      t.mousetrap.bind( e.keys, e.handler, e.action );
    } );
  }

  reset() {
    const t = this;
    t.mousetrap.reset();
  }

  unbindAll( t: any ) {
    const r = this;
    // TODO: check this
    // @ts-ignore
    r.mousetrap.unbind( flatMap( t, 'keys' ) );
  }

  trigger( r: any, t: any ) {
    const x = this;
    x.mousetrap.trigger( r, t );
  }
}
